<?php

namespace Drupal\issuu_viewer\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Provides a default Issuu viewer widget.
 *
 * @FieldWidget(
 *   id = "issuu_viewer_default",
 *   label = @Translation("Issuu viewer"),
 *   field_types = {
 *     "issuu_viewer_document_id"
 *   },
 * )
 */
class IssuuViewerDefaultWidget extends WidgetBase {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element['value'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Document'),
      '#default_value' => $items[$delta]->value,
      '#description' => $this->t('Enter the Issuu embed URL or a document ID.
       E.g. https://e.issuu.com/embed.html?u=redactive&d=act_apr20_full, https://issuu.com/redactive/docs/act_apr20_full or 100318163929-24d2670dcbd84b368afec3f0ee73325c'),
    ];

    $element += [
      '#type' => 'fieldset',
    ];

    return $element;
  }

}
